package net.minecraft.thKaguyaMod.client;

import net.minecraft.client.model.ModelBase;
import net.minecraft.client.model.ModelRenderer;
import net.minecraft.entity.Entity;
import net.minecraft.thKaguyaMod.*;

import cpw.mods.fml.relauncher.Side;
import cpw.mods.fml.relauncher.SideOnly;

@SideOnly(Side.CLIENT)
public class ModelKinkakuzi extends ModelBase
{
	
	//ボートを元にしているため、boatだらけだが、気にするな！
	
    public ModelRenderer boatSides[];

    public ModelKinkakuzi()
    {
    	/*Minecraftのモデルの基本事項
    	基本的にテクスチャに64x32の画像を使用
    	ボックスタイプのモデルしか扱えない
    	ボックスのサイズ＝テクスチャのサイズと考えていい
    	例えば横幅が10の箱ならば、そこに設定されるテクスチャも10ドット分使用する
    	横幅6、高さ4、奥行き3の箱を考えたとき、イメージとしてはテクスチャはこのようになる
    	000000111111222222000000
    	000000111111222222000000
    	000000111111222222000000
    	333333444444555555666666
    	333333444444555555666666
    	333333444444555555666666
    	333333444444555555666666
    	0は未使用部と考えて、ボックス型は6面存在するためこのように６つの部分に分けれれることになる。
    	この配置は人間の頭で言うと、
    	1は頭の上　2は頭の下　3は頭右　4は顔　5は頭左　6は頭後ろにあたる
    	一番左上にあたる座標はModelRenderer(this,x,y)で設定可能。
    	*/
    	
        boatSides = new ModelRenderer[5];//配列で５つ用意しているが、ここでは0だけ使う。　多分これほど単純なものでない限り、配列を使うためあえて残してある。
        boatSides[0] = new ModelRenderer(this, 0, 0);//テクスチャ座標0,0を左上にする
    	//ボックスを追加する。　当たり判定にも使われる？（Entity側で制御してるかも）
    	//addBox(X座標、Z座標、Y座標、X方向のサイズ、Z方向のサイズ、Y方向のサイズ、？（倍率？）)
    	//サイズはテクスチャのサイズそのもの
    	boatSides[0].addBox(-15, -15, -2, 30,30 , 2, 0.0F);
        //boatSides[0].setRotationPoint(0.0F, 0 + byte3, 0.0F);
        boatSides[0].rotateAngleX = ((float)Math.PI / 2F);
    }

    /**
     * Sets the models various rotation angles then renders the model.
     */
    public void render(Entity par1Entity, float par2, float par3, float par4, float par5, float par6, float par7)
    {
        //for (int i = 1; i < 5; i++)
        //{
          //  boatSides[i].render(par7);
        //}
    	boatSides[0].render(par7);//描画　par7は気にしなくていいと思う
    }

    /**
     * Sets the models various rotation angles.
     */
    public void setRotationAngles(float f, float f1, float f2, float f3, float f4, float f5)
    {
    }
}
